package com.github.gkutiel.flip.processor;

import java.util.List;

import javax.lang.model.element.Name;
import javax.lang.model.type.TypeKind;
import javax.lang.model.type.TypeMirror;

class Method {
	static class Param {
		final String type;
		final String name;

		public Param(final TypeMirror type, final Name name) {
			this.type = type.toString();
			this.name = name.toString();
		}
	}

	final String returnType;
	final String name;
	final List<Param> params;

	public Method(final TypeMirror returnType, final Name name, final List<Param> params) {
		this.returnType = returnType.getKind() == TypeKind.VOID ? null : returnType.toString();
		this.name = name.toString();
		this.params = params;
	}
}
